Rem ********************************************
Rem ********************************************
Rem ****                                    ****
Rem ****                                    ****
Rem ****  ROTINAS PARA LCD GRFICO 128 X 64 ****
Rem ****                                    ****
Rem ****         CONTROLADOR KS0108B        ****
Rem ****                                    ****
Rem ****    Desenvolvidas em BASCOM 8051    ****
Rem ****                                    ****
Rem ****             Agosto/2006            ****
Rem ****                                    ****
Rem ****    Rotinas para uso livre          ****
Rem ****                                    ****
Rem ****                                    ****
Rem ********************************************
Rem ********************************************


Rem Ajustes no compilador :
Rem
Rem OPTIONS - COMPILER - MISC - BYTE END : &h80
Rem Cristal 11.0592Mhz
Rem


$large
$regfile = "89S8252.DAT"

Dim X As Byte
Dim Y As Byte
Dim Z As Byte
Dim Status As Byte
Dim Dadow As Byte
Dim Dador As Byte
Dim Cs As Byte
Dim Modo As Bit
Dim Cnt1 As Byte
Dim Cnt2 As Byte
Dim P As Integer
Dim I As Byte
Dim Linha As Byte
Dim Coluna As Byte
Dim Dx As Byte
Dim Dy As Byte

Dim L1 As Byte
Dim L2 As Byte
Dim C1 As Byte
Dim C2 As Byte
Dim L As Byte
Dim C As Byte
Dim Aux1 As Integer


Dim Dinc1 As Integer
Dim Dinc2 As Integer
Dim Xinc1 As Integer
Dim Xinc2 As Integer
Dim Yinc1 As Integer
Dim Yinc2 As Integer

Dim _l1 As Byte
Dim _l2 As Byte
Dim _c1 As Byte
Dim _c2 As Byte
Dim Raio As Byte

Dim Buffer As String * 16
Dim Carac As String * 1

Dim Aux2 As Byte
Dim Aux3 As Byte
Dim Aux4 As String * 1
Dim Aux5 As Byte

Rs Alias P2.5
Rw Alias P2.4
E Alias P2.3
Cs1 Alias P2.2
Cs2 Alias P2.0
Rst Alias P2.1

Db0 Alias P1.0
Db1 Alias P1.1
Db2 Alias P1.2
Db3 Alias P1.3
Db4 Alias P1.4
Db5 Alias P1.5
Db6 Alias P1.6
Db7 Alias P1.7

Declare Sub Display_onoff(modo As Bit)
Declare Sub Readstatus
Declare Sub Readdata
Declare Sub Writedata(dadow As Byte)
Declare Sub Waitlcdready
Declare Sub Set_y(y As Byte)
Declare Sub Set_x(x As Byte)
Declare Sub Set_z(z As Byte)
Declare Sub _cs1
Declare Sub _cs2
Declare Sub Clear_display
Declare Sub Pixel(linha As Byte , Coluna As Byte , Modo As Bit)
Declare Sub Line(l1 As Byte , C1 As Byte , L2 As Byte , C2 As Byte)
Declare Sub Rect(_l1 As Byte , _c1 As Byte , _l2 As Byte , _c2 As Byte)
Declare Sub Circle(_l1 As Byte , _c1 As Byte , Raio As Byte)
Declare Sub Text(_l1 As Byte , _c1 As Byte , Buffer As String * 10)
Declare Sub Defsprite(dinc1 As Integer , C1 As Byte , C2 As Byte , L1 As Byte , L2 As Byte , _l1 As Byte)
Declare Sub Putsprite(dinc1 As Integer , _l1 As Byte , _c1 As Byte)


Call Defsprite(1 , &B00100110 , &B01011001 , &B00101111 , &B01011001 , &B00100110)       ' Monstro
Call Defsprite(2 , &B00000000 , &B00000000 , &B00000000 , &B00000000 , &B00000000)       ' Branco
Call Defsprite(3 , &B00001000 , &B01001100 , &B01111101 , &B01001100 , &B00001000)       ' Nave
Call Defsprite(4 , &B10000001 , &B00100100 , &B10001000 , &B00100010 , &B01000000)       ' Exploso 1
Call Defsprite(5 , &B10011000 , &B01010010 , &B01100101 , &B10001000 , &B01010111)       ' Exploso 2


Principal:



    Call Clear_display

    Call Line(0 , 0 , 0 , 127)

    Call Line(0 , 0 , 63 , 0)

    Call Line(0 , 127 , 63 , 127)

    Call Line(63 , 0 , 63 , 127)

    Call Line(0 , 0 , 63 , 127)

    Call Line(63 , 0 , 0 , 127)

    Call Line(5 , 10 , 40 , 100)

    Call Rect(30 , 30 , 50 , 50)

    Call Circle(32 , 63 , 10)

    Call Circle(10 , 10 , 10)

    Call Circle(40 , 80 , 15)

    Call Circle(32 , 63 , 25)

    Wait 1

    Aux5 = 33
    Call Clear_display
    For Aux2 = 0 To 55 Step 8
      For Aux3 = 0 To 120 Step 8
          Aux4 = Chr(aux5)
          Call Text(aux2 , Aux3 , Aux4)
          Incr Aux5
      Next Aux3
    Next Aux2

    Wait 1


    Tela_jogo:
       Call Clear_display

       Call Line(0 , 0 , 0 , 127)
       Call Line(0 , 0 , 63 , 0)
       Call Line(0 , 127 , 63 , 127)
       Call Line(63 , 0 , 63 , 127)

    For Aux2 = 1 To 122 Step 3
       Call Putsprite(3 , 55 , Aux2)
       Waitms 1
       Call Putsprite(2 , 55 , Aux2)
    Next Aux2

    Call Putsprite(1 , 10 , 63)

    For Aux2 = 122 To 63 Step -1
       Call Putsprite(3 , 55 , Aux2)
       Waitms 1
       Call Putsprite(2 , 55 , Aux2)
    Next Aux2

    Call Putsprite(3 , 55 , 63)

    For Aux2 = 54 To 10 Step -1
      Call Pixel(aux2 , 63 , 1)
    Next Aux2

    For Aux2 = 0 To 2
       Call Putsprite(4 , 10 , 63)
       Waitms 1
       Call Putsprite(5 , 10 , 63)
    Next Aux2

    Call Text(5 , 120 , "1")

    Call Rect(20 , 40 , 40 , 80)

    Call Text(26 , 42 , "*FIM*")

    Wait 2


   Goto Tela_jogo




Goto Principal




Rem ---Rotinas bsicas do LCD (KS0108B)---


Sub Display_onoff(modo As Bit)
  Call Waitlcdready

  Reset Rs
  Reset Rw

  Reset Db7
  Reset Db6
  Set Db5
  Set Db4
  Set Db3
  Set Db2
  Set Db1
  Db0 = Modo

  Set E
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Reset E
End Sub


Sub Readstatus
  P1 = 255

  Reset Rs
  Set Rw

  Set E
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Status = P1
  Reset E
End Sub


Sub Readdata
  Call Waitlcdready
  P1 = 255

  Set Rw
  Set Rs

  Set E
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Dador = P1
  Reset E
End Sub



Sub Writedata(dadow As Byte)
  Call Waitlcdready

  Set Rs
  Reset Rw

  P1 = Dadow

  Set E
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Reset E
End Sub


Sub Set_y(y As Byte)
  Call Waitlcdready

  Reset Rs
  Reset Rw

  Reset Db7
  Set Db6
  Db5 = Y.5
  Db4 = Y.4
  Db3 = Y.3
  Db2 = Y.2
  Db1 = Y.1
  Db0 = Y.0

  Set E
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Reset E
End Sub


Sub Set_x(x As Byte)
  Call Waitlcdready

  Reset Rs
  Reset Rw

  Set Db7
  Reset Db6
  Set Db5
  Set Db4
  Set Db3
  Db2 = X.2
  Db1 = X.1
  Db0 = X.0

  Set E
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Reset E
End Sub


Sub Set_z(z As Byte)
  Call Waitlcdready

  Reset Rs
  Reset Rw

  Set Db7
  Set Db6
  Db5 = Z.5
  Db4 = Z.4
  Db3 = Z.3
  Db2 = Z.2
  Db1 = Z.1
  Db0 = Z.0

  Set E
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
  Reset E
End Sub


Sub _cs1
  Call Waitlcdready

  Set Cs1
  Reset Cs2
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
End Sub


Sub _cs2
  Call Waitlcdready

  Reset Cs1
  Set Cs2
  Nop
  Nop
  Nop
  Nop
  Nop
  Nop
End Sub


Sub Waitlcdready
  Call Readstatus
  While Status.7 = 1
     Call Readstatus
  Wend
End Sub


Sub Clear_display
   Call Display_onoff(1)

   For Cnt1 = 0 To 7
     For Cnt2 = 0 To 63
       Call _cs1
       Nop
       Nop
       Call Set_x(cnt1)
       Nop
       Nop
       Call Set_y(cnt2)
       Nop
       Nop
       Call Set_z(0)
       Nop
       Nop
       Call Writedata(0)
       Nop
       Nop
       Nop
       Nop

       Call _cs2
       Nop
       Nop
       Call Set_x(cnt1)
       Nop
       Nop
       Call Set_y(cnt2)
       Nop
       Nop
       Call Set_z(0)
       Nop
       Nop
       Call Writedata(0)
       Nop
       Nop
       Nop
       Nop
     Next Cnt2
   Next Cnt1
Rem Call Display_onoff(1)
End Sub


Rem ---Rotinas de nvel intermedirio ---


Sub Pixel(linha As Byte , Coluna As Byte , Modo As Bit)
    If Coluna < 64 Then
       Call _cs1
       Y = Coluna
    Else
       Call _cs2
       Y = Coluna - 64
    End If

    I = Linha Mod 8
    P = Linha - I
    X = P / 8

    Call Set_x(x)
    Call Set_y(y)
    Call Set_z(0)

    Call Readdata
    Call Readdata

    If Modo = 1 Then
       Set Dador.i
    Else
       Reset Dador.i
    End If

    Call Set_x(x)
    Call Set_y(y)
    Call Set_z(0)

    Call Writedata(dador)
End Sub


Sub Line(l1 As Byte , C1 As Byte , L2 As Byte , C2 As Byte)

  If C2 > C1 Then
     Dx = C2 - C1
  Else
     Dx = C1 - C2
  End If

  If L2 > L1 Then
     Dy = L2 - L1
  Else
     Dy = L1 - L2
  End If

  If Dx >= Dy Then
     Cnt2 = Dx + 1
     Aux1 = 2 * Dy
     Aux1 = Aux1 - Dx

     Dinc1 = Dy * 2
     Dinc2 = Dy - Dx
     Dinc2 = Dinc2 * 2
     Xinc1 = 1
     Xinc2 = 1
     Yinc1 = 0
     Yinc2 = 1
  Else
     Cnt2 = Dy + 1
     Aux1 = 2 * Dx
     Aux1 = Aux1 - Dy

     Dinc1 = Dx * 2
     Dinc2 = Dx - Dy
     Dinc2 = Dinc2 * 2
     Xinc1 = 0
     Xinc2 = 1
     Yinc1 = 1
     Yinc2 = 1
  End If


  If C1 > C2 Then
     If Xinc1 = 1 Then Xinc1 = -1
     If Xinc2 = 1 Then Xinc2 = -1
  End If

  If L1 > L2 Then
     If Yinc1 = 1 Then Yinc1 = -1
     If Yinc2 = 1 Then Yinc2 = -1
  End If

  L = L1
  C = C1


  For Cnt1 = 1 To Cnt2
      Call Pixel(l , C , 1)
      If Aux1 < 0 Then
          Aux1 = Aux1 + Dinc1
          C = C + Xinc1
          L = L + Yinc1
      Else
          Aux1 = Aux1 + Dinc2
          C = C + Xinc2
          L = L + Yinc2
      End If
  Next Cnt1


End Sub



Sub Rect(_l1 As Byte , _c1 As Byte , _l2 As Byte , _c2 As Byte)
  Call Line(_l1 , _c1 , _l1 , _c2)
  Call Line(_l1 , _c2 , _l2 , _c2)
  Call Line(_l1 , _c1 , _l2 , _c1)
  Call Line(_l2 , _c1 , _l2 , _c2)
End Sub



Sub Circle(_l1 As Byte , _c1 As Byte , Raio As Byte)
  C = 0
  L = Raio
  Dinc2 = 2 * Raio
  Dinc1 = 3 - Dinc2


  While C <= L

    C1 = _c1 + C
    L1 = _l1 + L
    Call Pixel(l1 , C1 , 1)

    C1 = _c1 + C
    L1 = _l1 - L
    Call Pixel(l1 , C1 , 1)

    C1 = _c1 - C
    L1 = _l1 + L
    Call Pixel(l1 , C1 , 1)

    C1 = _c1 - C
    L1 = _l1 - L
    Call Pixel(l1 , C1 , 1)

    C1 = _c1 + L
    L1 = _l1 + C
    Call Pixel(l1 , C1 , 1)

    C1 = _c1 + L
    L1 = _l1 - C
    Call Pixel(l1 , C1 , 1)

    C1 = _c1 - L
    L1 = _l1 + C
    Call Pixel(l1 , C1 , 1)

    C1 = _c1 - L
    L1 = _l1 - C
    Call Pixel(l1 , C1 , 1)


    If Dinc1 < 0 Then
       Dinc2 = 4 * C
       Dinc1 = Dinc1 + Dinc2
       Dinc1 = Dinc1 + 6
    Else
       Dinc2 = C - L
       Dinc2 = Dinc2 * 4
       Dinc2 = Dinc2 + 10
       Dinc1 = Dinc1 + Dinc2
       L = L - 1
    End If
    C = C + 1
  Wend
End Sub


Sub Text(_l1 As Byte , _c1 As Byte , Buffer As String * 10)
  Cnt2 = Len(buffer)
  C1 = _c1
  For Cnt1 = 1 To Cnt2
    Carac = Mid(buffer , Cnt1 , 1)

    Aux1 = Asc(carac)
    Aux1 = Aux1 - 32
    Aux1 = Aux1 * 5

    Restore Caracteres
    For Dinc1 = 1 To Aux1
      Read Raio
    Next Dinc1

    For _c2 = 1 To 5
       Read Raio
       L1 = _l1
       For L2 = 0 To 7
          Call Pixel(l1 , C1 , Raio.l2)
          Incr L1
       Next L2
       Incr C1
    Next _c2

    C1 = C1 + 3
  Next Cnt1
End Sub


Sub Defsprite(dinc1 As Integer , C1 As Byte , C2 As Byte , L1 As Byte , L2 As Byte , _l1 As Byte)
  Dinc1 = Dinc1 * 5

  Writeeeprom C1 , Dinc1
  Incr Dinc1

  Writeeeprom C2 , Dinc1
  Incr Dinc1

  Writeeeprom L1 , Dinc1
  Incr Dinc1

  Writeeeprom L2 , Dinc1
  Incr Dinc1

  Writeeeprom _l1 , Dinc1
  Incr Dinc1
End Sub


Sub Putsprite(dinc1 As Integer , _l1 As Byte , _c1 As Byte)

  Dinc1 = Dinc1 * 5

  C1 = _c1
  For _c2 = 1 To 5
     Readeeprom Raio , Dinc1
     Incr Dinc1
     L1 = _l1
     For L2 = 0 To 7
        Call Pixel(l1 , C1 , Raio.l2)
        Incr L1
     Next L2
     Incr C1
  Next _c2
End Sub


Caracteres:
   Data &H0 , &H0 , &H0 , &H0 , &H0                           ' 32 -  ESP - 20
   Data &H0 , &H0 , &H4F , &H0 , &H0                          ' 33 -  !   - 21
   Data &H0 , &H7 , &H0 , &H7 , &H0                           ' 34 -  "   - 22"
   Data &H14 , &H7F , &H14 , &H7F , &H14                      ' 35 -  #   - 23
   Data &H24 , &H2A , &H7F , &H2A , &H12                      ' 36 -  $   - 24
   Data &H23 , &H13 , &H8 , &H64 , &H62                       ' 37 -  %   - 25
   Data &H36 , &H49 , &H55 , &H22 , &H50                      ' 38 -  &   - 26
   Data &H0 , &H5 , &H3 , &H0 , &H0                           ' 39 - ESC - 27
   Data &H1C , &H22 , &H41 , &H0 , &H0                        ' 40 -  ( - 28
   Data &H0 , &H0 , &H41 , &H22 , &H1C                        ' 41 -  ) - 29
   Data &H14 , &H8 , &H3E , &H8 , &H14                        ' 42 -  * - 2a
   Data &H8 , &H8 , &H3E , &H8 , &H8                          ' 43 -  + - 2b
   Data &H0 , &H50 , &H30 , &H0 , &H0                         ' 44 -  , - 2c
   Data &H8 , &H8 , &H8 , &H8 , &H8                           ' 45 -  - - 2d
   Data &H0 , &H60 , &H60 , &H0 , &H0                         ' 46 -  . - 2e
   Data &H20 , &H10 , &H8 , &H4 , &H2                         ' 47 -  / - 2f
   Data &H3E , &H51 , &H49 , &H45 , &H3E                      ' 48 -  0 - 30
   Data &H0 , &H42 , &H7F , &H40 , &H0                        ' 49 -  1 - 31
   Data &H42 , &H61 , &H51 , &H49 , &H46                      ' 50 -  2 - 32
   Data &H21 , &H41 , &H45 , &H4B , &H31                      ' 51 -  3 - 33
   Data &H18 , &H14 , &H12 , &H7F , &H10                      ' 52 -  4 - 34
   Data &H27 , &H45 , &H45 , &H45 , &H39                      ' 53 -  5 - 35
   Data &H3C , &H4A , &H49 , &H49 , &H30                      ' 54 -  6 - 36
   Data &H1 , &H71 , &H9 , &H5 , &H3                          ' 55 -  7 - 37
   Data &H36 , &H49 , &H49 , &H49 , &H36                      ' 56 -  8 - 38
   Data &H06 , &H49 , &H49 , &H29 , &H1E                      ' 57 -  9 - 39 / / Corrige
   Data &H0 , &H36 , &H36 , &H0 , &H0                         ' 58 -  : - 3a
   Data &H0 , &H56 , &H36 , &H0 , &H0                         ' 59 -  ; - 3b
   Data &H8 , &H14 , &H22 , &H41 , &H0                        ' 60 -  < - 3c
   Data &H14 , &H14 , &H14 , &H14 , &H14                      ' 61 -  = - 3d
   Data &H0 , &H41 , &H22 , &H14 , &H8                        ' 62 -  > - 3e
   Data &H2 , &H1 , &H51 , &H9 , &H6                          ' 63 -  Print - 3f
   Data &H32 , &H49 , &H79 , &H41 , &H3E                      ' 64 -  @ - 40
   Data &H7E , &H11 , &H11 , &H11 , &H7E                      ' 65 -  A - 41
   Data &H7F , &H49 , &H49 , &H49 , &H36                      ' 66 -  B - 42
   Data &H3E , &H41 , &H41 , &H41 , &H22                      ' 67 -  C - 43
   Data &H7F , &H41 , &H41 , &H22 , &H1C                      ' 68 -  D - 44
   Data &H7F , &H49 , &H49 , &H49 , &H41                      ' 69 -  E - 45
   Data &H7F , &H9 , &H9 , &H9 , &H1                          ' 70 -  F - 46
   Data &H3E , &H41 , &H49 , &H49 , &H7A                      ' 71 -  G - 47
   Data &H7F , &H8 , &H8 , &H8 , &H7F                         ' 72 -  H - 48
   Data &H0 , &H41 , &H7F , &H41 , &H0                        ' 73 -  I - 49
   Data &H20 , &H40 , &H41 , &H3F , &H1                       ' 74 -  J - 4a
   Data &H7F , &H8 , &H14 , &H22 , &H41                       ' 75 -  K - 4b
   Data &H7F , &H40 , &H40 , &H40 , &H40                      ' 76 -  L - 4c
   Data &H7F , &H2 , &HC , &H2 , &H7F                         ' 77 -  M - 4d
   Data &H7F , &H4 , &H8 , &H10 , &H7F                        ' 78 -  N - 4e
   Data &H3E , &H41 , &H41 , &H41 , &H3E                      ' 79 -  O - 4f
   Data &H7F , &H9 , &H9 , &H9 , &H6                          ' 80 -  P - 50
   Data &H3E , &H41 , &H51 , &H21 , &H5E                      ' 81 -  Q - 51
   Data &H7F , &H9 , &H19 , &H29 , &H46                       ' 82 -  R - 52
   Data &H46 , &H49 , &H49 , &H49 , &H31                      ' 83 -  S - 53
   Data &H1 , &H1 , &H7F , &H1 , &H1                          ' 84 -  T - 54
   Data &H3F , &H40 , &H40 , &H40 , &H3F                      ' 85 -  U - 55
   Data &H1F , &H20 , &H40 , &H20 , &H1F                      ' 86 -  V - 56
   Data &H3F , &H40 , &H38 , &H40 , &H3F                      ' 87 -  W - 57
   Data &H63 , &H14 , &H8 , &H14 , &H63                       ' 88 -  X - 58
   Data &H7 , &H8 , &H70 , &H8 , &H7                          ' 89 -  Y - 59
   Data &H61 , &H51 , &H49 , &H45 , &H43                      ' 90 -  Z - 5a
   Data &H7F , &H41 , &H41 , &H0 , &H0                        ' 91 -  [ - 5b
   Data &H2 , &H4 , &H8 , &H10 , &H20                         ' 92 -  \ - 5c
   Data &H0 , &H0 , &H41 , &H41 , &H7F                        ' 93 -  ] - 5d
   Data &H4 , &H2 , &H1 , &H2 , &H4                           ' 94 -  ^ - 5e
   Data &H40 , &H40 , &H40 , &H40 , &H40                      ' 95 -  _ - 5f
   Data &H0 , &H1 , &H2 , &H4 , &H0                           ' 96 -  ` - 60
   Data &H20 , &H54 , &H54 , &H54 , &H78                      ' 97 -  A - 61
   Data &H7F , &H48 , &H44 , &H44 , &H38                      ' 98 -  B - 62
   Data &H38 , &H44 , &H44 , &H44 , &H20                      ' 99 -  C - 63
   Data &H38 , &H44 , &H44 , &H48 , &H7F                      ' 100   D - 64
   Data &H38 , &H54 , &H54 , &H54 , &H18                      ' 101   E - 65
   Data &H8 , &H7E , &H9 , &H1 , &H2                          ' 102   F - 66
   Data &HC , &H52 , &H52 , &H52 , &H3E                       ' 103   G - 67
   Data &H7F , &H8 , &H4 , &H4 , &H78                         ' 104   H - 68
   Data &H0 , &H44 , &H7D , &H40 , &H0                        ' 105   I - 69
   Data &H0 , &H20 , &H40 , &H44 , &H3D                       ' 106   J - 6a
   Data &H7F , &H10 , &H28 , &H44 , &H0                       ' 107   K - 6b
   Data &H0 , &H41 , &H7F , &H40 , &H0                        ' 108   L - 6c
   Data &H7C , &H4 , &H18 , &H4 , &H78                        ' 109   M - 6d
   Data &H7C , &H8 , &H4 , &H4 , &H78                         ' 110   N - 6e
   Data &H38 , &H44 , &H44 , &H44 , &H38                      ' 111   O - 6f
   Data &H7C , &H14 , &H14 , &H14 , &H8                       ' 112   P - 70
   Data &H8 , &H14 , &H14 , &H18 , &H7C                       ' 113   Q - 71
   Data &H7C , &H8 , &H4 , &H4 , &H8                          ' 114   R - 72
   Data &H48 , &H54 , &H54 , &H54 , &H20                      ' 115   S - 73
   Data &H4 , &H3F , &H44 , &H40 , &H20                       ' 116   T - 74
   Data &H3C , &H40 , &H40 , &H20 , &H7C                      ' 117   U - 75
   Data &H1C , &H20 , &H40 , &H20 , &H1C                      ' 118   V - 76
   Data &H3C , &H40 , &H30 , &H40 , &H3C                      ' 119   W - 77
   Data &H44 , &H28 , &H10 , &H28 , &H44                      ' 120   X - 78
   Data &HC , &H50 , &H50 , &H50 , &H3C                       ' 121   Y - 79
   Data &H44 , &H64 , &H54 , &H4C , &H44                      ' 122   Z - 7a
   Data &H8 , &H36 , &H41 , &H0 , &H0                         ' 123   { - 7b
   Data &H0 , &H0 , &H7F , &H0 , &H0                          ' 124   | - 7c
   Data &H0 , &H0 , &H41 , &H36 , &H8                         ' 125   } - 7d
   Data &H0 , &H8 , &H4 , &H8 , &H4                           ' 126   ~ - 7e



